<?php
/**
 * @package	AcySMS for Joomla!
 * @version	3.2.0
 * @author	acyba.com
 * @copyright	(C) 2009-2016 ACYBA S.A.R.L. All rights reserved.
 * @license	GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');
?><?php

class ACYSMSGateway_smsir_gateway extends ACYSMSGateway_default_gateway{

	private $wsdl_link = "http://ip.sms.ir/ws/SendReceive.asmx?wsdl";
	private $wsdl_link_users = "http://ip.sms.ir/ws/Users.asmx?wsdl";

	public $username;
	public $senderName;
	public $waittosend = 0;
	public $indexMessage = 0;
	public $messageToSend = array();
	public $messageResults = array();


	public $sendMessage = true;
	public $deliveryReport = true;
	public $answerManagement = true;

	public $domain = 'sms.ir';
	public $port = 80;

	public $name = 'sms.ir';
	public $creditsUrl = 'https://www.acyba.com/acysms/purchase-sms.html';


	public $isclubnumber = false;


	public function openSend($message, $phone){
		$this->indexMessage += 1;

		$oneMessage = new stdClass();
		$oneMessage->receiver = $this->checkNum($phone);
		$oneMessage->body = $message;
		$this->messageToSend[$this->indexMessage] = $oneMessage;

		return $this->indexMessage;
	}

	public function GetCredit() {
		
		$parameters['userName'] = $this->username;
		$parameters['password'] = $this->password;

		date_default_timezone_set('Asia/Tehran');
		$client= new SoapClient($this->wsdl_link);
		$UserCredit = $client->GetUserCredit($parameters);
		$UserCreditget = get_object_vars($UserCredit);
		$UserCreditresult = $UserCreditget['GetUserCreditResult'];
		$UserCreditres = doubleval($UserCreditresult);
		return $UserCreditres;
	}

	public function SendSMStoCustomerclubContacts($message) {
	
		date_default_timezone_set('Asia/Tehran');
		$client= new SoapClient($this->wsdl_link);
		
		$parameters['userName'] = $this->username;
		$parameters['password'] = $this->password;
		$parameters['messageBody'] = $message;
		$parameters['message'] = $message; 

		$SendMessage = $client->SendMessageCustomerClub($parameters);
		
		$SendMessageWithLine = get_object_vars($SendMessage);
		$sendresult = $SendMessageWithLine['SendMessageCustomerClubResult'];

		if($sendresult == 1){
			return true;
		} else {
			return false;
		}
	}
	
	public function inserttosmscustomerclub($user_name,$mobile){
		if($mobile){
			$parameters['userName'] = $this->username;
			$parameters['password'] = $this->password;
			$parameters['lastName'] = "lastName";
			$parameters['mobile'] = $mobile[0];

			date_default_timezone_set('Asia/Tehran');
			$client= new SoapClient($this->wsdl_link_users);
			@$insertTocustomerclub = $client->InserNewContactCustomerClub($parameters);
			
			$customerclubget = get_object_vars($insertTocustomerclub);
			$customerclubresult = $customerclubget['InserNewContactCustomerClubResult'];
			if($customerclubresult == 1){
				return true;
			} else {
				return false;
			}
		}
	}
	
	public function displayConfig(){

		$isclubnumberData[] = JHTML::_('select.option', '1', JText::_('SMS_YES'));
		$isclubnumberData[] = JHTML::_('select.option', '0', JText::_('SMS_NO'));

		$isclubnumber = empty($this->isclubnumber) ? 0 : 1;

		$isclubnumberOption = JHTML::_('acysmsselect.radiolist', $isclubnumberData, 'data[senderprofile][senderprofile_params][isclubnumber]', '', 'value', 'text', $isclubnumber);

		?>

		<table>
			<tr>
				<td class="key">
					<label for="senderprofile_username"><?php echo ACYSMS::tooltip('نام کاربری شما در sms.ir', JText::_('SMS_USERNAME'), '', JText::_('SMS_USERNAME')); ?></label>
				</td>
				<td>
					<input type="text" name="data[senderprofile][senderprofile_params][username]" id="senderprofile_username" class="inputbox" value="<?php echo htmlspecialchars(@$this->username, ENT_COMPAT, 'UTF-8'); ?>"/>
				</td>
			</tr>
			<tr>
				<td class="key">
					<label for="senderprofile_password"><?php echo ACYSMS::tooltip('رمز عبور شما در sms.ir', JText::_('SMS_PASSWORD'), '', JText::_('SMS_PASSWORD')); ?></label>
				</td>
				<td>
					<input type="password" name="data[senderprofile][senderprofile_params][password]" id="senderprofile_password" class="inputbox" value="<?php echo htmlspecialchars(@$this->password, ENT_COMPAT, 'UTF-8'); ?>"/>
				</td>
			</tr>
			<tr>
				<td class="key">
					<label for="senderprofile_linenumber"><?php echo ACYSMS::tooltip('شماره ارسالی پیامک در sms.ir', JText::_('SMS_FROM'), '', JText::_('SMS_FROM')); ?></label>
				</td>
				<td>
					<input type="text" name="data[senderprofile][senderprofile_params][linenumber]" id="senderprofile_linenumber" class="inputbox" value="<?php echo htmlspecialchars(@$this->linenumber, ENT_COMPAT, 'UTF-8'); ?>"/>
				</td>
			</tr>
			<tr>
				<td class="key">
					<label for="senderprofile_isclubnumber"><?php echo ACYSMS::tooltip(JText::_('SMS_IS_CUSTOMER_CLUB_NUMBER'), JText::_('SMS_IS_CUSTOMER_CLUB_NUMBER'), '', JText::_('SMS_IS_CUSTOMER_CLUB_NUMBER')); ?></label>
				</td>
				<td>
					<?php echo $isclubnumberOption; ?>
				</td>
			</tr>
			<tr>
				<td class="key">
					<label for="senderprofile_getcredit"><?php echo ACYSMS::tooltip(JText::_('SMS_IS_GET_CREDIT'), JText::_('SMS_IS_GET_CREDIT'), '', JText::_('SMS_IS_GET_CREDIT')); ?></label>
				</td>
				<td>
					<?php echo $this->GetCredit()." پیامک "; ?>
				</td>
			</tr>
		</table>

		<?php
	}
	
	public function closeSend($idMessage){
		if(!empty($this->messageToSend)){
			$this->_sendMessages();
			$this->messageToSend = array();
		}
		if(empty($this->messageResults[$idMessage])){
			$this->errors[] = 'Status not found for the message ID : '.$idMessage;
			$this->errors[] = print_r($this->messageResults, true);
			return false;
		}

		if(!empty($this->messageResults[$idMessage]->smsid)) $this->smsid = $this->messageResults[$idMessage]->smsid;
		if(!empty($this->messageResults[$idMessage]->info)) $this->errors[] = $this->messageResults[$idMessage]->info;
		return $this->messageResults[$idMessage]->status;
	}

	private function _sendMessages(){

		$isclubnumber = $this->isclubnumber;
		$messagearray = $this->messageToSend;
		$messagevars = get_object_vars($messagearray[1]);
		$messagereceiver = $messagevars['receiver'];
		$number = substr($messagereceiver, -10);
		$messagebody = $messagevars['body'];
		$numbers[] = doubleval($number);

		$parameters['userName'] = $this->username;
		$parameters['password'] = $this->password;
		$parameters['mobileNos'] = $numbers;
		$parameters['messages'] = $messagebody;
		$parameters['lineNumber'] = $this->linenumber; 
		$parameters['sendDateTime'] = date("Y-m-d")."T".date("H:i:s");
		
		date_default_timezone_set('Asia/Tehran');
		$client= new SoapClient($this->wsdl_link);

		$check_if_in_cc = $this->inserttosmscustomerclub("",$numbers);
		$SendToOneCustomerClubresult = 0;
		if($isclubnumber == 1){
			$ccparameters['userName'] = $this->username;
			$ccparameters['password'] = $this->password;
			$ccparameters['messageBody'] = $messagebody;
			$ccparameters['mobile'] = $numbers[0];
			$ccparameters['message'] = $messagebody;

			$SendMessageToOneCustomerClub = $client->SendMessageToOneCustomerClub($ccparameters);
			$SendToOneCustomerClub = get_object_vars($SendMessageToOneCustomerClub);
			$SendToOneCustomerClubresult = $SendToOneCustomerClub['SendMessageToOneCustomerClubResult'];
		} else {

			$SendMessage = $client->SendBulkMessageWithLineNumber($parameters);
			
			$SendMessageWithLine = get_object_vars($SendMessage);
			@$sendresult = $SendMessageWithLine['SendBulkMessageWithLineNumberResult'];
			if($sendresult){
				$transid = get_object_vars($sendresult);
			}
			@$transidvalue = $transid['long'];
		}
		
		if(isset($transidvalue) || ($SendToOneCustomerClubresult == 1)){
			$answer = new stdClass();
			@$answer->status = 1;
			@$answer->info = nl2br($result->status_message);
			foreach($this->messageToSend as $oneIndex => $oneMessageSent){
				$this->messageResults[$oneIndex] = $answer;
			}
		} else {
			@$resmessage = $result->messages;
			if($resmessage){
				foreach($result->messages as $oneId => $oneMessage){
					$answer = new stdClass();
					$answer->smsid = empty($oneMessage->message_id) ? '' : $oneMessage->message_id;
					$answer->status = $oneMessage->status;
					if(!empty($oneMessage->status_message)) $answer->info = $oneMessage->status_message;
					$this->messageResults[$oneId] = $answer;
				}
			}
		}
		
		$this->indexMessage = 0;
	}

	public function afterSaveConfig($senderProfile){
		if(in_array(JRequest::getCmd('task'), array('save', 'apply'))) $this->displayBalance();
	}

	public function getBalance(){
		$fsockParameter = "GET /api/getBalance?apiKey=".urlencode($this->username)." HTTP/1.1\r\n";
		$fsockParameter .= "Host: www.acygateway.com \r\n";
		$fsockParameter .= "Content-type: application/x-www-form-urlencoded\r\n\r\n";

		$idConnection = $this->sendRequest($fsockParameter);
		$result = $this->readResult($idConnection);

		if($result === false){
			ACYSMS::enqueueMessage(implode('\n', $this->errors), 'error');
			return false;
		}
		if(!strpos($result, '200 OK')){
			$this->errors[] = 'Error 200 KO => '.$result;
			return false;
		}
		$res = json_decode(trim(substr($result, strpos($result, "\r\n\r\n"))));


		if(!empty($res->status)){
			$res->user_nb_credits = substr($res->user_nb_credits, 0, strpos($res->user_nb_credits, '.') + 3);
			return array("default" => $res->user_nb_credits);
		}else{
			ACYSMS::enqueueMessage($res->status_message, 'error');
			return false;
		}
	}

	private function displayBalance(){

		$balance = $this->getBalance();

		if($balance === false){
			ACYSMS::enqueueMessage(implode('<br />', $this->errors), 'error');
			return false;
		}


		ACYSMS::enqueueMessage(JText::sprintf('SMS_CREDIT_LEFT_ACCOUNT', $balance["default"]), 'message');
	}


	public function deliveryReport(){

		$callbackInformationsEncoded = JRequest::getVar("callbackInformations", '');
		$callbackInfoDecoded = json_decode($callbackInformationsEncoded);
		if(empty($callbackInfoDecoded)) return;



		$status = array();
		$status[0] = "Not sent";
		$status[1] = "Sent";
		$status[2] = "Accepted by the gateway";
		$status[3] = "Sent to the operator";
		$status[4] = "Buffered";
		$status[5] = "Delivered";
		$status[-1] = "Not delivered";
		$status[-2] = "Timed out";
		$status[-99] = "Error unknown status";

		$deliveryInformations = array();

		foreach($callbackInfoDecoded as $oneCallback){
			$oneInformation = new stdClass();
			$oneInformation->statsdetails_error = array();


			$messageStatus = empty($oneCallback->status) ? '' : $oneCallback->status;
			$completed_time = empty($oneCallback->completed_time) ? '' : $oneCallback->completed_time;

			if(empty($messageStatus)) $oneInformation->statsdetails_error[] = 'Empty status received';
			if($messageStatus == 5){
				if(empty($completed_time)){
					$oneInformation->statsdetails_received_date = time();
				}else $oneInformation->statsdetails_received_date = $completed_time;
			}

			$smsId = empty($oneCallback->message_id) ? '' : $oneCallback->message_id;
			if(empty($smsId)) $oneInformation->statsdetails_error[] = 'Can t find the message_id';

			if(!isset($status[$messageStatus])){
				$oneInformation->statsdetails_error[] = 'Unknow status : '.$messageStatus;
				$oneInformation->statsdetails_status = -99;
			}else{
				$oneInformation->statsdetails_status = $messageStatus;
				$oneInformation->statsdetails_error[] = $status[$messageStatus];
			}

			$oneInformation->statsdetails_sms_id = $smsId;

			$deliveryInformations[] = $oneInformation;
		}

		return $deliveryInformations;
	}

	public function answer(){

		$callbackInformationsEncoded = JRequest::getVar("callbackInformations", '');
		$callbackInfoDecoded = json_decode($callbackInformationsEncoded);
		if(empty($callbackInfoDecoded)) return;

		$answerInformations = array();

		foreach($callbackInfoDecoded as $oneAnswerInformation){

			$oneInformation = new stdClass();
			$oneInformation->statsdetails_error = array();

			$oneInformation->answer_date = empty($oneAnswerInformation->received_time) ? time() : $oneAnswerInformation->received_time;

			$oneInformation->answer_body = empty($oneAnswerInformation->answer_body) ? '' : $oneAnswerInformation->answer_body;

			$answerSender = empty($oneAnswerInformation->answer_sender) ? '' : $oneAnswerInformation->answer_sender;
			$answerReceiver = empty($oneAnswerInformation->answer_receiver) ? '' : $oneAnswerInformation->answer_receiver;

			if(!empty($answerSender)) $oneInformation->answer_from = '+'.$answerSender;
			if(!empty($answerReceiver)) $oneInformation->answer_to = '+'.$answerReceiver;

			$oneInformation->answer_sms_id = empty($oneAnswerInformation->message_id) ? '' : $oneAnswerInformation->message_id;

			$answerInformations[] = $oneInformation;
		}

		return $answerInformations;
	}
}
